{\rtf0\ansi{\fonttbl\f0\fmodern Ohlfs;}
\paperw11780
\paperh11300
\margl120
\margr120
{\colortbl;\red0\green0\blue92;\red0\green0\blue0;\red85\green85\blue85;\red51\green85\blue51;\red221\green102\blue0;}
\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\f0\b0\i0\ulnone\fs20\gray39\fc1\cf1 //\
//	GRGradientButtonCell : ButtonCell\
//\
//	By Anders Bertelrud\
//	Copyright (c) 1995-1996 Anders Bertelrud\
//\

\gray0\fc0\cf0 \

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\fc0\cf0 #import <dpsclient/psops.h>\
#import <dpsclient/wraps.h>\

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\fc0\cf0 #import <appkit/NXImage.h>\

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\fc0\cf0 #import <appkit/View.h>\
#import "GRGradientButtonCell.h"\
#import "GRGradientFunctions.h"\
\
\
\

\gray39\fc1\cf1 //\
//	GRGradientButtonCell class\
//
\gray0\fc0\cf0 \
@implementation GRGradientButtonCell\
\
\

\gray39\fc1\cf1 // Class globals
\gray0\fc0\cf0 \
static NXImage *	GRBlankImage = nil;		
\gray39\fc1\cf1 // This is needed because of problems with IB.
\gray0\fc0\cf0 \
\
\

\gray39\fc1\cf1 ////////////////////////////////////// Private functions ///////////////////////////////////////\

\gray0\fc0\cf0 \
\
static inline void GRAdjustRectangle (NXRect * rectangle, float leftInset, float topInset,\
									  float rightInset, float bottomInset, BOOL viewIsFlipped)\

\gray39\fc1\cf1 	// Adjusts the given rectangle by insetting each edge by the corresponding amount. If the\
	// flag viewIsFlipped is YES, the adjustments are appropriate for a rectangle in a flipped\
	// coordinate system; if it is NO, the adjustments will be correct only if the rectangle\
	// is in a non-flipped coordinate system.
\gray0\fc0\cf0 \
\{\
	if (rectangle)\
	\{\
		rectangle->origin.x += leftInset;\
		rectangle->origin.y += (viewIsFlipped ? topInset : bottomInset);\
		rectangle->size.width -= (leftInset + rightInset);\
		rectangle->size.height -= (topInset + bottomInset);\
	\}\
\}\
\
\
static inline void GROffsetRectangle (NXRect * rectangle, float dx, float dy,\
									  BOOL viewIsFlipped)\

\gray39\fc1\cf1 	// Offsets the given rectangle by the given amounts. If viewIsFlipped is YES, the offsets\
	// are appropriate for a rectangle in a flipped coordinate system; if it is NO, the offsets\
	// will be correct only if the rectangle is in a non-flipped coordinate system.
\gray0\fc0\cf0 \
\{\
	if (rectangle)\
	\{\
		rectangle->origin.x += dx;\
		rectangle->origin.y += (viewIsFlipped ? -dy : dy);\
	\}\
\}\
\
\
static inline NXImage * GRCreateDimmedImageWithZone (NXZone * zone, NXImage * image)\

\gray39\fc1\cf1 	// Creates and returns a dimmed version of the given image by compositing it into a\
	// transparent image of the same size but with 50% alpha. The resulting image can be\
	// composited anywhere with NX_SOVER and will let half of the background show through.\
	// In our case the background is a gray gradient; the result is a dimmed effect. The\
	// NXImage is allocated in the given zone.
\gray0\fc0\cf0 \
\{\
	NXImage *	dimmedImage;\

\fc2\cf2 	NXRect		imageBounds = \{0, 0, 0, 0\};\
\
	[image getSize:&imageBounds.size];\
	
\fc0\cf0 dimmedImage
\fc2\cf2  = [[NXImage allocFromZone:zone] initSize:&imageBounds.size];\
	if ([
\fc0\cf0 dimmedImage
\fc2\cf2  lockFocus])\
	\{\
		PSsetgray(NX_BLACK);\
		PSsetalpha(0.5);\
		NXRectFill(&imageBounds);\
		[image composite:NX_SIN toPoint:&imageBounds.origin];\
		[
\fc0\cf0 dimmedImage
\fc2\cf2  unlockFocus];\
		return dimmedImage;\
	\}\
	else\
		return [dimmedImage free];\

\fc0\cf0 \}\
\
\
\

\gray39\fc1\cf1 //////////////////////// Creating and destroying GRGradientButtonCells /////////////////////////\

\gray0\fc0\cf0 \
\
+ initialize\
\{\

\gray39\fc1\cf1 	// This is very ugly. It seems that IB cannot deal with button cells that have nil images.\
	// We create a small blank image to use for "no image", and set it in -initIconCell:.
\gray0\fc0\cf0 \
	if (self == [GRGradientButtonCell self])\
	\{\
		NXRect	r = \{0, 0, 1, 1\};\
\
		GRBlankImage = [[NXImage alloc] initSize:&r.size];\
		if ([GRBlankImage lockFocus])\
		\{\
			PSsetalpha(0.0);\
			NXRectFill(&r);\
			PSsetalpha(1.0);\
			[GRBlankImage unlockFocus];\
		\}\
	\}\
	return self;\
\}\
\
\

\fc2\cf2 - initIconCell:(const char *)iconName												 	 
\gray333\fc3\cf3 // d.i.
\gray0\fc2\cf2 \

\fc0\cf0 \{\
	self = [super initIconCell:iconName];\
	dimmedWhenDisabled = YES;\
	[self setImage:GRBlankImage];		
\gray39\fc1\cf1 // See comment in +initialize
\gray0\fc0\cf0 \

\fc2\cf2 	return self;\

\fc0\cf0 \}\
\
\

\fc2\cf2 - initTextCell:(const char *)textString												 	 
\gray333\fc3\cf3 // d.i.
\gray0\fc2\cf2 \

\fc0\cf0 \{\

\gray39\fc1\cf1 	// GRGradientButtonCells cannot display text. Sorry...
\gray0\fc0\cf0 \

\fc2\cf2 	return 
\fc0\cf0 [self initIconCell:NULL]
\fc2\cf2 ;\

\fc0\cf0 \}\
\
\
- init\
\{\
	return [self initIconCell:NULL];\
\}\
\
\
- copyFromZone:(NXZone *)zone\
\{\
	self = [super copyFromZone:zone];\
	dimmedNormalImage = [dimmedNormalImage copyFromZone:zone];\
	dimmedAlternateImage = [dimmedAlternateImage copyFromZone:zone];\
	return self;\
\}\
\
\

\fc2\cf2 - free\
\{\
	[
\fc0\cf0 dimmedAlternateImage
\fc2\cf2  free];\
	[dimmedNormalImage free];\
	return [super free];\
\}
\fc0\cf0 \
\
\
\

\gray39\fc1\cf1 ///////////////////////// Setting whether to dim when cell is disabled /////////////////////////\

\gray0\fc0\cf0 \
\
- (BOOL)isDimmedWhenDisabled
\fc2\cf2 \

\fc0\cf0 \{\
	return dimmedWhenDisabled;\
\}\
\
\
- (void)setDimmedWhenDisabled:(BOOL)flag
\fc2\cf2 \

\fc0\cf0 \{\
	dimmedWhenDisabled = flag;\
\}\
\
\
\

\gray39\fc1\cf1 /////////////////////////////////////// Setting the icon ///////////////////////////////////////\

\gray0\fc0\cf0 \
\
- setImage:
\fc2\cf2 (NXImage *)image\
\{\
	[dimmedNormalImage free];\
	dimmedNormalImage = nil;\
	if (image != nil)\
	\{\

\gray277\fc4\cf4 //		ALAssert1([image isKindOf:[NXImage self]], "Image, if not nil, must be a kind of "\
//		  "NXImage (but it's %s).", ALDS(image));\

\gray0\fc2\cf2 		dimmedNormalImage = 
\fc0\cf0 GRCreateDimmedImageWithZone(
\fc2\cf2 [self zone], 
\fc0\cf0 image)
\fc2\cf2 ;\
	\}\
	[super setImage:image];\
	return self;\
\}
\fc0\cf0 \
\
\
- setAltImage:
\fc2\cf2 (NXImage *)image\
\{\
	[dimmedAlternateImage free];\
	dimmedAlternateImage = nil;\
	if (image != nil)\
	\{\

\gray277\fc4\cf4 //		ALAssert1([image isKindOf:[NXImage self]], "Image, if not nil, must be a kind of "\
//		  "NXImage (but it's %s).", ALDS(image));\

\gray0\fc2\cf2 		dimmedAlternateImage = 
\fc0\cf0 GRCreateDimmedImageWithZone(
\fc2\cf2 [self zone], 
\fc0\cf0 image)
\fc2\cf2 ;\
	\}\
	[super setAltImage:image];\
	return self;\
\}
\fc0\cf0 \
\
\
\

\gray39\fc1\cf1 /////////////////////////////////// Drawing and highlighting ///////////////////////////////////\

\gray0\fc0\cf0 \
\
- drawInside:(const NXRect *)cellFrame inView:(View *)view\

\fc2\cf2 \{\
	NXRect				inside;\
	register NXImage *	image;\
	register 
\fc0\cf0 BOOL
\fc2\cf2 		viewIsFlipped;\
	register 
\fc0\cf0 BOOL
\fc2\cf2 		dwd;\
\
\
	viewIsFlipped = [view isFlipped];\
	dwd = 
\fc0\cf0 dimmedWhenDisabled;\

\fc2\cf2 	inside = *cellFrame;\
\

\gray39\fc1\cf1 	// If the button cell is bordered (which actually means "raised bezel" in the case of\
	// ButtonCells), we adjust the drawing rectangle accordingly.
\gray0\fc2\cf2 \
	if (bcFlags1.bordered)\

\fc0\cf0 		GRAdjustRectangle(&inside, 1, 1, 2, 2, viewIsFlipped);\

\fc2\cf2 	image = (
\fc0\cf0 dwd &&
\fc2\cf2  cFlags1.disabled) ? dimmedNormalImage : icon.bmap.normal;\
\

\gray495\fc5\cf5 	// [@@] Still something wrong with this code: if a button whose state is 1 is pressed, the\
	// button isn't highlighted as it should. [fixa detta s smningom]\

\gray0\fc2\cf2 	if (cFlags1.highlighted)\
	\{\

\gray39\fc1\cf1 		// Highlighted.
\gray0\fc2\cf2 \
		if (bcFlags1.bordered && bcFlags1.pushIn)\

\fc0\cf0 			GROffsetRectangle(&inside, 1, -1, viewIsFlipped);\

\fc2\cf2 		if (bcFlags1.lightByBackground || bcFlags1.lightByGray)\
			GRDrawGrayGradient(
\fc0\cf0 inside
\fc2\cf2 , (NX_LTGRAY+NX_WHITE)/2.0, NX_WHITE);\
		else\
			GRDrawGrayGradient(inside, (NX_DKGRAY+NX_LTGRAY)/2.0, (NX_LTGRAY+NX_WHITE)/2.0);\

\gray39\fc1\cf1 		// The state-checking below is to make change-by-toggle work right.
\gray0\fc2\cf2 \
		if (bcFlags1.lightByContents 
\gray495\fc5\cf5 && !(bcFlags1.changeContents && cFlags1.state)
\gray0\fc2\cf2 )\
			image = (
\fc0\cf0 dwd &&
\fc2\cf2  cFlags1.disabled) ? dimmedAlternateImage : icon.bmap.alternate;\
	\}\
	else if (cFlags1.state)\
	\{\

\gray39\fc1\cf1 		// Alternate state.
\gray0\fc2\cf2 \
		if (bcFlags1.changeBackground || bcFlags1.changeGray)\
			GRDrawGrayGradient(
\fc0\cf0 inside
\fc2\cf2 , (NX_LTGRAY+NX_WHITE)/2.0, NX_WHITE);\
		else\
			GRDrawGrayGradient(inside, (NX_DKGRAY+NX_LTGRAY)/2.0, (NX_LTGRAY+NX_WHITE)/2.0);\
		if (bcFlags1.changeContents)\
			image = (
\fc0\cf0 dwd &&
\fc2\cf2  cFlags1.disabled) ? dimmedAlternateImage : icon.bmap.alternate;\
	\}\
	else\
		GRDrawGrayGradient(inside, (NX_DKGRAY+NX_LTGRAY)/2.0, (NX_LTGRAY+NX_WHITE)/2.0);\
\

\gray39\fc1\cf1 	// If it's an icon cell, draw the icon (for now always centered).
\gray0\fc2\cf2 \
	if (cFlags1.type == NX_ICONCELL && image != nil)\
	\{\
		NXSize	imageSize;\
		NXPoint	pt;\
\
		[image getSize:&imageSize];\
		pt.x = NX_MIDX(&inside) - imageSize.width/2;\
		if (pt.x < NX_X(&inside))\
			pt.x = NX_X(&inside);\
		if (viewIsFlipped)\
		\{\
			pt.y = NX_MIDY(&inside) + imageSize.height/2;\
			if (pt.y > NX_MAXY(&inside))\
				pt.y = NX_MAXY(&inside);\
		\}\
		else\
		\{\
			pt.y = NX_MIDY(&inside) - imageSize.height/2;\
			if (pt.y < NX_Y(&inside))\
				pt.y = NX_Y(&inside);\
		\}\
		[image composite:NX_SOVER toPoint:&pt];\
	\}\
	bcFlags1.lastState = (cFlags1.state ? YES : NO);\
	return self;\
\}\
\

\fc0\cf0 \
\

\gray39\fc1\cf1 ////////////////////////////////// Reading from typed streams //////////////////////////////////\

\gray0\fc0\cf0 \
\
- read:(NXTypedStream *)stream\
\{\
	self = [super read:stream];\
	dimmedWhenDisabled = YES;\

\fc2\cf2 	if (cFlags1.type == NX_ICONCELL && icon.bmap.normal != nil)\
		dimmedNormalImage = 
\fc0\cf0 GRCreateDimmedImageWithZone(
\fc2\cf2 [self zone], 
\fc0\cf0 icon.bmap.normal)
\fc2\cf2 ;\
	if (cFlags1.type == NX_ICONCELL && icon.bmap.
\fc0\cf0 alternate
\fc2\cf2  != nil)\
		
\fc0\cf0 dimmedAlternateImage
\fc2\cf2  = 
\fc0\cf0 GRCreateDimmedImageWithZone(
\fc2\cf2 [self zone], 
\fc0\cf0 icon.bmap.alternate)
\fc2\cf2 ;\

\fc0\cf0 	return self;\
\}\
\
\
\
@end
}
