{\rtf0\ansi{\fonttbl\f1\fmodern Ohlfs;}
\paperw11780
\paperh11300
\margl120
\margr120
{\colortbl;\red0\green0\blue92;\red0\green0\blue85;\red0\green0\blue0;}
\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\f1\b0\i0\ulnone\fs20\gray39\fc1\cf1 //\
//	GRGradientFrameView : FrameView\
//\
//	By Anders Bertelrud\

\gray35\fc2\cf2 //	Copyright (c) 1995-1996 Anders Bertelrud\
//\

\gray0\fc0\cf0 \

\fc3\cf3 #import <math.h>\

\fc0\cf0 #import <dpsclient/psops.h>\
#import <defaults/defaults.h>\
#import <appkit/Application.h>\

\fc3\cf3 #import "GRGradientFunctions.h"\
#import "GRGradientFrameView.h"\
\
\
\

\gray39\fc1\cf1 //\
//	Names of defaults strings\
//
\gray0\fc3\cf3 \
#define		GRGradientTitleBarsEnabled		"GRGradientTitleBarsEnabled"\
#define		GRGradientTitleBarHue			"GRGradientTitleBarHue"\
#define		GRGradientTitleBarSaturation	"GRGradientTitleBarSaturation"\
\
\
\

\gray39\fc1\cf1 //\
//	GRGradientFrameView class\
//
\gray0\fc3\cf3 \
@implementation GRGradientFrameView\
\
\

\gray39\fc1\cf1 // Class globals
\gray0\fc3\cf3 \
static float		GRGradientHue = .666667;			
\gray39\fc1\cf1 // Hue used for gradient
\gray0\fc3\cf3 \
static float		GRMenuSaturation = 0.5;				
\gray39\fc1\cf1 // Saturation for menus
\gray0\fc3\cf3 \
static float		GRKeyWindowSaturation = 0.5;		
\gray39\fc1\cf1 //    - " -   for key window
\gray0\fc3\cf3 \
static float		GRMainWindowSaturation = 0.25;		
\gray39\fc1\cf1 //    - " -   for main window
\gray0\fc3\cf3 \
static float		GROtherWindowSaturation = 0.0;		
\gray39\fc1\cf1 //    - " -   for all other windows
\gray0\fc3\cf3 \
\
\
\

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\fc3\cf3 + (void)install\
\{\
	[self poseAs:[FrameView self]];\
\}\
\
\
+ (void)installIfAppropriate\
\{\
	const char *	enabledValue;\
\
	enabledValue = NXGetDefaultValue([NXApp appName], GRGradientTitleBarsEnabled);\
	if (enabledValue && strcmp(enabledValue, "Yes") == 0)\
		[self install];\
\}\
\
\
+ initialize\
\{\
	if (self == [GRGradientFrameView self])\
	\{\
		NXDefaultsVector	titleBarDefaults = \{\
								\{GRGradientTitleBarsEnabled, "NO"\},\
								\{GRGradientTitleBarHue, "0.6666667"\},\
								\{GRGradientTitleBarSaturation, "0.5"\},\
								\{NULL\}\
							\};\
		const char *		huePreference;\
		const char *		saturationPreference;\
\
\

\gray39\fc1\cf1 		// Register defaults.
\gray0\fc3\cf3 \

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\fc3\cf3 		NXRegisterDefaults([NXApp appName], titleBarDefaults);\

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\fc3\cf3 \

\gray39\fc1\cf1 		// Get hue and saturation constants from the defaults database.
\gray0\fc3\cf3 \
		huePreference = NXGetDefaultValue([NXApp appName], GRGradientTitleBarHue);\
		if (huePreference && huePreference[0])\
			GRGradientHue = atof(huePreference);\
		saturationPreference = NXGetDefaultValue([NXApp appName], GRGradientTitleBarSaturation);\
		if (saturationPreference && saturationPreference[0])\
		\{\
			GRMenuSaturation = atof(saturationPreference) * 1.0;\
			GRKeyWindowSaturation = atof(saturationPreference) * 1.0;\
			GRMainWindowSaturation = atof(saturationPreference) * 0.5;\
			GROtherWindowSaturation = atof(saturationPreference) * 0.0;\
		\}\
	\}\
	return self;\
\}\
\
\
static inline void GRClipRectFill (NXRect * origRect, const NXRect * visRect)\

\gray39\fc1\cf1 	// When this function is compiled with -O optimization, the compiler generates assembly\
	// code identical to NeXT's private ClipRectFill.\

\gray0\fc3\cf3 \{\
	if (NXIntersectionRect(visRect, origRect))\
		NXRectFill(origRect);\
\}\
\
\
static inline void GRClipFrameRect (NXRect * origRect, const NXRect * visRect)\

\gray39\fc1\cf1 	// When this function is compiled with -O optimization, the compiler generates assembly\
	// code identical to NeXT's private ClipFrameRect.\

\gray0\fc3\cf3 \{\
	NXRect	r = *origRect;\
	NXRect	sliceRect;\
\
	if (NXContainsRect(visRect, &r))\
		NXFrameRect(&r);\
	else\
	\{\
		register int	i;\
\
		for (i = NX_XMIN; i <= NX_YMAX; i++)\
		\{\
			NXDivideRect(&r, &sliceRect, 1.0, i);\
			GRClipRectFill(&sliceRect, visRect);\
		\}\
	\}\
\}\
\
\
static void _GRDrawTitleBar (id self, NXRect titleBarRect, const NXRect * visRect,\
							 float saturation, float startBrightness, float endBrightness,\
							 float titleGray, 
\fc0\cf0 BOOL
\fc3\cf3  menuStyle)\
\{\
	NXRect		sliceRect;\
\
\

\gray35\fc2\cf2 	// Rita ramen.
\gray0\fc3\cf3 \
	if (menuStyle)\
	\{\

\gray35\fc2\cf2 		// Rita vre och vnstra kanten.
\gray0\fc3\cf3 \
		PSsetgray(NX_DKGRAY);\
		NXDivideRect(&titleBarRect, &sliceRect, 1, NX_XMIN);\
		GRClipRectFill(&sliceRect, visRect);\
		NXDivideRect(&titleBarRect, &sliceRect, 1, NX_YMAX);\
		GRClipRectFill(&sliceRect, visRect);\
\

\gray35\fc2\cf2 		// Rita nedre och hgra kanten.
\gray0\fc3\cf3 \
		PSsetgray(NX_BLACK);\
		NXDivideRect(&titleBarRect, &sliceRect, 1, NX_XMAX);\
		GRClipRectFill(&sliceRect, visRect);\
		NXDivideRect(&titleBarRect, &sliceRect, 1, NX_YMIN);\
		GRClipRectFill(&sliceRect, visRect);\
	\}\
	else\
	\{\
		PSsetgray(NX_BLACK);\
		GRClipFrameRect(&titleBarRect, visRect);\
		NXInsetRect(&titleBarRect, 1, 1);\
	\}\
\

\gray35\fc2\cf2 	// Rita vre och vnstra kanten.
\gray0\fc3\cf3 \
	PSsethsbcolor(GRGradientHue, saturation * .5, .8);\
	NXDivideRect(&titleBarRect, &sliceRect, 1, NX_XMIN);\
	GRClipRectFill(&sliceRect, visRect);\
	NXDivideRect(&titleBarRect, &sliceRect, 1, NX_YMAX);\
	GRClipRectFill(&sliceRect, visRect);\
\

\gray35\fc2\cf2 	// Rita nedre och hgra kanten.
\gray0\fc3\cf3 \
	PSsethsbcolor(GRGradientHue, saturation, .2);\
	NXDivideRect(&titleBarRect, &sliceRect, 1, NX_XMAX);\
	GRClipRectFill(&sliceRect, visRect);\
	NXDivideRect(&titleBarRect, &sliceRect, 1, NX_YMIN);\
	GRClipRectFill(&sliceRect, visRect);\
\

\gray35\fc2\cf2 	// Rita gradienten.
\gray0\fc3\cf3 \
	GRDrawHSBGradient(titleBarRect, GRGradientHue, saturation, startBrightness, endBrightness);\
\

\gray35\fc2\cf2 	// Rita titeln.
\gray0\fc3\cf3 \
	[self _drawTitleStringIn:visRect withColor:titleGray];\
\}\
\
\
- _drawTitledFrame:(const NXRect *)rectangles :(int)nrRectangles\
\{\
	const NXCoord	titleBarHeight = 23;\
	const NXRect *	visRect = rectangles;\
	NXRect			titleBarRect, r;\
	NXRect			restOfWindowRect;\
\
	restOfWindowRect = bounds;\
	NXDivideRect(&restOfWindowRect, &titleBarRect, titleBarHeight, NX_YMAX);\
	r = titleBarRect;\
	if (NXIntersectionRect(visRect, &r))\
	\{\
		if ([window isKeyWindow])\
			_GRDrawTitleBar(self, titleBarRect, &rectangles[0], GRKeyWindowSaturation,\
			  .2, .5, NX_WHITE, NO);\
		else if ([window isMainWindow])\
			_GRDrawTitleBar(self, titleBarRect, &rectangles[0], GRMainWindowSaturation,\
			  .2, .5, NX_WHITE, NO);\
		else\
			_GRDrawTitleBar(self, titleBarRect, &rectangles[0], GROtherWindowSaturation,\
			  .4, .7, NX_BLACK, NO);\
	\}\
	[super _drawTitledFrame:&restOfWindowRect :1];\
	return self;\
\}\
\
\
- _drawMenuFrame:(const NXRect *)rectangles :(int)nrRectangles\
\{\
	const NXCoord	titleBarHeight = 23;\
	const NXRect *	visRect = rectangles;\
	NXRect			titleBarRect, r;\
	NXRect			restOfWindowRect;\
\
	restOfWindowRect = bounds;\
	NXDivideRect(&restOfWindowRect, &titleBarRect, titleBarHeight, NX_YMAX);\
	r = titleBarRect;\
	if (NXIntersectionRect(visRect, &r))\
	\{\
		_GRDrawTitleBar(self, titleBarRect, &rectangles[0], GRMenuSaturation, .2, .5, NX_WHITE,\
		  YES);\
	\}\
	[super _drawMenuFrame:&restOfWindowRect :1];\
	return self;\
\}\
\
\
\
@end
}
