{\rtf0\ansi{\fonttbl\f0\fmodern Ohlfs;}
\paperw11780
\paperh12580
\margl120
\margr120
{\colortbl;\red0\green0\blue92;\red0\green0\blue85;\red0\green0\blue0;}
\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\f0\b0\i0\ulnone\fs20\gray39\fc1\cf1 //\
//	GRGradientFunctions\
//\
//	By Anders Bertelrud\

\gray35\fc2\cf2 //	Copyright (c) 1995-1996 
\gray39\fc1\cf1 Anders Bertelrud\
//\
//	This module contains two functions to draw NeXTSTEP 4.0 style gradients.\

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\gray35\fc2\cf2 //	Both functions work by creating an 8-bits-per-sample bitmap on the fly and then drawing it\
//	to the current context using NXDrawBitmap (which dithers it down to the screen depth). It\
//	would almost certainly be more efficient to switch on the desired pixel depth and dither as\
//	the pixels values are written. Since this is a quick hack to get blue gradient title bars\
//	and gray gradient buttons to work, though, I didn't think it would be worth the time.\

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\gray35\fc2\cf2 //	To make these functions reasonable efficient, fixed-point arithmetic is used (16 bits for\
//	the whole number and 16 for the fraction). It's a simple linear interpolation, as in any\
//	rasterizer, except that it's special-cased for the 45 degree diagonal gradients we're\
//	interested in here. Rasterization 101. Simple stuff.\
//	The functions are nowhere near optimized, though. About the only optimization made is the\
//	fixed-point interpolation.\
//	These functions can be used separately, without the other classes in this package.\

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\gray39\fc1\cf1 //\

\gray0\fc0\cf0 \

\fc3\cf3 #import <appkit/graphics.h>\
\
\
void GRDrawHSBGradient (NXRect rectangle, float hue, float saturation, float startBrightness,\
		float endBrightness);\

\gray35\fc2\cf2 	// Fills the given rectangle with a gradient in any hue. The gradient is NS4.0-style, i.e.\
	// brightness is interpolated from the upper left corner to the lower right corner of the\
	// rectangle. "Hue" and "saturation" remain constant throughout the gradient, and brightness\
	// is interpolated from "startBrightness" (in the upper left corner) to "endBrightness" (in\
	// the lower right corner). Lines perpendicular to the upper-left to lower-right diagonal\
	// get constant colour.\
	// The size of the input rectangle isn't checked. If you pass in a ten-thousand-by-ten-\
	// thousand rectangle, you will fill up swap space. Remember, this is a hack. :-)\

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\fc3\cf3 \
void GRDrawGrayGradient (NXRect rectangle, float startBrightness, float endBrightness);
\fc0\cf0 \

\pard\tx480\tx960\tx1440\tx1920\tx2400\tx2880\tx3360\tx3840\tx4320\tx4800\tx5280\tx5760\tx6240\tx6720\tx7200\tx7680\tx8160\tx8640\tx9120\tx9600\tx10080\tx10560\tx11040\gray35\fc2\cf2 	// Like GRDrawHSBGradient, except that the saturation is always zero (which makes the hue\
	// irrelevant). Using this function is faster than calling GRDrawGrayGradient passing zero\
	// for "saturation".\

}
